/*****************************
* @File Name: MENU.C
* @Author	: JZHG
* @Time     : 2012-12-06
* @Version  : V1.0
******************************/

#include "MENU.h"
#include "LCD12864.h"
#include "KEY.h"
#include "IRDA.h"
#include "DS1302.h"
#include "DS18B20.h"
#include "GTM900.h"
#include "JD.h"
#include "yanwu.h"
#include "Counter.h"

u8 Alarm_Temp=200;

/***********************************************************
* ƣMENU_X
* ܣϵͳ˵
*           ڲ:     ڲ
***********************************************************/


/*********************************
        һ˵
**********************************/

void MENU_A0( void )
{
      LCD12864_Clear();	// 
  	  LCD12864_Show_hz(0,0,"˵");
	  LCD12864_Show_hz(0,1,"1.ҵ  2.ͨ  ");
	  LCD12864_Show_hz(0,2,"3.  4.  ");
	  LCD12864_Show_hz(0,3,"5.  6.˳  ");
}

/*********************************
        ˵
**********************************/

void MENU_B0( void )
{
      LCD12864_Clear();	// 
  	  LCD12864_Show_hz(0,0,"  ҵ  ");
	  LCD12864_Show_hz(0,1,"1.  2.");
	  LCD12864_Show_hz(0,2,"3.յ  4.ˮ");
	  LCD12864_Show_hz(0,3,"5.  6.");
}

void MENU_B1( void )
{
      LCD12864_Clear();	// 
  	  LCD12864_Show_hz(0,0,"  ͨ  ");
	  LCD12864_Show_hz(0,1,"绰    ҵ绰");
	  LCD12864_Show_hz(0,2,"ӵ绰    ");
	  LCD12864_Show_hz(0,3,"ͨѶ¼    ռ");
}

void MENU_B2( void )
{
      LCD12864_Clear();	// 
      LCD12864_Show_hz(0,0,"    ");
	  LCD12864_Show_hz(0,1,"¶  ʱ  ");
      LCD12864_Show_hz(0,2,"    ");
	  LCD12864_Show_hz(0,3,"ģʽ    "); 
}

void MENU_B3( void )
{	
  LCD12864_Clear();	// 				   
  LCD12864_Show_hz(0,0,"    ");
  LCD12864_Show_hz(0,1,"1.  2.");
  LCD12864_Show_hz(0,2,"3.  4.");					 
  LCD12864_Show_hz(0,3,"5.ֵͲ  6.汾");  
}

void MENU_B4( void )
{
  LCD12864_Clear();	// 
  LCD12864_Show_hz(0,0,"    ");
  LCD12864_Show_hz(0,1,"1.  2.  ");
  LCD12864_Show_hz(0,2,"3.С˵  4.Ӱ  ");
  LCD12864_Show_hz(0,3,"5.ͼ  6.Ϸ  ");  
}

/*********************************
        ˵
**********************************/

void MENU_NULL( void )
{
  LCD12864_Clear();	// 
  LCD12864_Show_hz(0,0,"𾴵ûã");
  LCD12864_Show_hz(0,1,"ùݲ֧  ");
  LCD12864_Show_hz(0,2,"  밴ؼ    ");
  LCD12864_Show_hz(0,3,"  һ    ");
}

/************************************
*		   ˵
*************************************/

void MENU_Counter( void )
{
	 LCD12864_Clear();	// 
	 counter( ); // 
}



/************************************
*		   ҵ˵
*************************************/

void MENU_JD( u8 num )
{
  static state_value[5]={0}; // ״ֵ̬
  LCD12864_Clear();	// 
  switch ( num )
  {
  	case 0:LCD12864_Show_hz(0,0,"    ");break;
	case 1:LCD12864_Show_hz(0,0,"      ");break;
	case 2:LCD12864_Show_hz(0,0,"  յ  ");break;
	case 3:LCD12864_Show_hz(0,0,"  ˮ    ");break;
	case 4:LCD12864_Show_hz(0,0,"    ");break; 
	case 5:LCD12864_Show_hz(0,0,"      ");break;
	default: break;
  }
  LCD12864_Show_hz(0,1,"1.  2.ر  ");
  LCD12864_Show_hz(0,2,"ؼ  ");
  if  ( state_value[num] == 1 )LCD12864_Show_hz(0,3,"ǰ״̬  "); 
  else LCD12864_Show_hz(0,3,"ǰ״̬ر  ");
   while ( IRDA_key != 12)
    {
	  IRDA_key=255;
	  while( IRDA_key==255 );
	  if ( IRDA_key==1 )
	  {
	  	 JD_Drive( num ,ON); // ҵ
		 LCD12864_Show_hz(5,3,"");
	     state_value[num]=1;
	  }
	  else if ( IRDA_key==2) 
	  {
	    
	  	JD_Drive( num ,OFF); // ҵ
		LCD12864_Show_hz(5,3,"ر");
		state_value[num]=0;
	  }
   }
}


void MENU_Version( void )
{
  LCD12864_Clear();	// 
  LCD12864_Show_hz(0,0,"ܼҾӹϵͳ");
  LCD12864_Show_hz(0,1,"ˣȪ  ");
  LCD12864_Show_hz(0,2,"        ˫    ");   
  LCD12864_Show_hz(0,3,"  V1.0    ");
}

void MENU_CallON( void )
{

    LCD12864_Clear();	// 
    LCD12864_Show_hz(0,0,"......");
    Call(CALLON);   // 
	LCD12864_Show_hz(0,0,": ");
	LCD12864_Show_hz(2,0,CALL_ON+3);
	LCD12864_Show_hz(0,1,"ɹ ^_^");
    LCD12864_Show_hz(0,2,"    밴ؼ  ");
    LCD12864_Show_hz(0,3,"            ");

}
void MENU_CallOFF( void )
{

    LCD12864_Clear();	// 
    LCD12864_Show_hz(0,0,"ҵ绰......");
    Call(CALLOFF);   // 
  	LCD12864_Show_hz(0,0,"һ: ");
	LCD12864_Show_hz(2,0,CALL_ON+3);
	LCD12864_Show_hz(0,1,"ɹ ^_^");
	LCD12864_Show_hz(2,2,"밴ؼ");
    LCD12864_Show_hz(3,3,"");

}
void MENU_GetCall( void )
{

    LCD12864_Clear();	// 
	if ( USART_flag )
	{
		USART_flag=0;
	    LCD12864_Show_hz(0,0,"......");
	    Call(GETCALL);   // 
	  	LCD12864_Show_hz(0,0,":  ");
		LCD12864_Show_hz(2,0,CALL_ON+3);
		LCD12864_Show_hz(0,1,"ɹ ^_^");
		Delay_nms(500);
	}
	else 
	{
	    LCD12864_Show_hz(0,0,"𾴵ûã");
		LCD12864_Show_hz(0,1,"ûյ磡");	
	}
  LCD12864_Show_hz(2,2,"밴ؼ");
  LCD12864_Show_hz(3,3,"");
}

void MENU_News( void )
{
  LCD12864_Clear();	// 
  LCD12864_Show_hz(0,0,"Ͷš");
  Send_ENNews(  );  // ӢĶ
  if ( USART_flag )
  {
     USART_flag = 0;
  	 LCD12864_Show_hz(0,0,"Ͷųɹ ^_^");
  }
  else 
  {
  	 LCD12864_Show_hz(0,0,"Ͷʧ....");
  }
  LCD12864_Show_hz(2,2,"밴ؼ");
  LCD12864_Show_hz(3,3,"");
}

//void MENU_SetNewsNum( void )
//{
//    u8 cnt=0;
//
//    IRDA_key=255;
//    LCD12864_Clear();	// 
//    LCD12864_Show_hz(0,0,"ֻ");
//    IRDA_key=255;
//    while(IRDA_key==255); 
//	LCD12864_SetXY(0,2);            // LCD꺯
//    while(IRDA_key!=12)     		//Ƿؼ
//    {
//		if(IRDA_key<10&&cnt<11)			//11λֻ
//		{
//		    
//			NEWS_LENGT[(cnt++)+3]=IRDA_key+48;
//        	LCD12864_Write_Data( LCD12864_DAT,IRDA_key+48);								
//		}
//        IRDA_key=255;
//        while(IRDA_key==255);			//ȴм              
//    } 
//    IRDA_key=255;
//	LCD12864_Show_hz(0,2,NEWS_LENGT);
//	LCD12864_Show_hz(2,3,"ɹ!");
//	Delay_nms(500);
//}

void MENU_SetTime( void )
{
	u8 temp=0,i, cnt=0;
	for(i=6;i>0;i--) //ڲ
	{
	        LCD12864_Clear();	// 
			switch(i)
			{
				case 6:LCD12864_Show_hz(0,0,":");break;
				case 5:LCD12864_Show_hz(0,0,":");break;
				case 4:LCD12864_Show_hz(0,0,":");break;
				case 3:LCD12864_Show_hz(0,0,"ʱ:");break;
				case 2:LCD12864_Show_hz(0,0,":");break;
				case 1:LCD12864_Show_hz(0,0,":");break;
				default:break;
			}
		    temp=0; // 
	        LCD12864_SetXY(0,2);         // LCD꺯
		    while(cnt<2)     			 //λ
	        {
			  	IRDA_key=255;  
			    while(IRDA_key==255);		//ȴм 
	            temp=(temp*10)+IRDA_key;
	            LCD12864_Write_Data( LCD12864_DAT, IRDA_key+48);  
				cnt++;
	        } 
		   temp = ((temp /10)<<4) +(temp%10);	   // תBCD
		   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, WP_STOP );// ȡд
		   switch(i)
		   {
		   		case 1: DS1302_WriteByteToAddr( DS1302_SECOND_WRITE, temp);break; // ڵʱ
				case 2: DS1302_WriteByteToAddr( DS1302_MINUTE_WRITE, temp);break; // ڵʱ
				case 3: DS1302_WriteByteToAddr( DS1302_HOUR_WRITE,   temp);break; // ڵʱ
				case 4: DS1302_WriteByteToAddr( DS1302_DATE_WRITE,   temp);break; // ڵʱ
				case 5: DS1302_WriteByteToAddr( DS1302_MONTH_WRITE,  temp);break; // ڵʱ
		        case 6: DS1302_WriteByteToAddr( DS1302_YEAR_WRITE,   temp);break; // ڵʱ
				default: break;
		   }
		   DS1302_WriteByteToAddr( DS1302_CONTROL_WRITE, WP_START );//
		   IRDA_key=255;  
		   while(IRDA_key==255);		//ȴм 
		   cnt=0;
		}
		IRDA_key=255; 
		LCD12864_Show_hz(2,3,"޸ĳɹ!");
}

void MENU_SetAlarmTemp( void )
{
    u8 temp=0;
    LCD12864_Clear();	// 
    LCD12864_Show_hz(0,0,"뱨¶");
    IRDA_key=255;
    while(IRDA_key==255); 
  	LCD12864_SetXY(0,2);         // LCD꺯
    while(IRDA_key!=12)     				//ȷϼ
    {
        temp=(temp*10)+IRDA_key;
        LCD12864_Write_Data( LCD12864_DAT,IRDA_key+48);
        IRDA_key=255;
        while(IRDA_key==255);			//ȴм              
    } 					
    IRDA_key=255;
    Alarm_Temp=temp;   		//±¶
	LCD12864_Show_hz(2,3,"޸ĳɹ!");
}
/***********************************************************
* ƣMENU_ShowTime
* ܣʾʱ亯
*           ڲ:    ڲ
***********************************************************/

void MENU_ShowTime( void )
{	   

   u8 T[8], D[8];
   DS1302_ReadTime( );// DS1302ȡʱ䱣ʱṹ
   T[0]= CurrentTime.Hour >>4;		// ʱ
   T[1]= CurrentTime.Hour &0x0f;
   T[2]= -3;
   T[3]= CurrentTime.Minute >>4;	// 
   T[4]= CurrentTime.Minute &0x0f;
   T[5]= -3;
   T[6]= CurrentTime.Second >>4;	// 
   T[7]= CurrentTime.Second &0x0f;

   D[0]= CurrentTime.Year >>4;	    // 
   D[1]= CurrentTime.Year &0x0f;
   D[2]= -3;
   D[3]= CurrentTime.Month >>4;	    // 
   D[4]= CurrentTime.Month &0x0f;
   D[5]= -3;
   D[6]= CurrentTime.Date >>4;	    // 
   D[7]= CurrentTime.Date &0x0f;
//   D[8]= CurrentTime.Week&0x0f;     // 
   LCD12864_Show_hz(0,2,"ڣ"); // LCDʾַ
   LCD12864_Show_hz(0,3,"ʱ䣺"); // LCDʾַ
//   LCD12864_ShowChar(2,0,"ڣ"); // LCDʾַ

   LCD12864_ShowNumS(3,2,8,D);	// ʾ
   LCD12864_ShowNumS(3,3,8,T);	// ʾʱ
//   LCD12864_ShowNum( 2, 3, D[8]); // LCDʾһλֺ
}

/***********************************************************
* ƣMENU_ShowTemperature
* ܣʾ¶Ⱥ
*           ڲ:      ڲ
***********************************************************/

void MENU_ShowTemperature(void)
{
	LCD12864_Show_hz(0,0,"ܼҾӹϵͳ");
	LCD12864_Show_hz(0,1,"¶ȣ");
	Read_18B20();
	LCD12864_SetXY(5,1);          // LCD꺯
	LCD12864_Write_Data( LCD12864_DAT,(zhengshu%100)/10+48);
	LCD12864_Write_Data( LCD12864_DAT,zhengshu%10+48);
	LCD12864_Write_Data( LCD12864_DAT,'.');
	LCD12864_Write_Data( LCD12864_DAT,xiaoshu1+48);
	LCD12864_Show_hz(7,1,"");
	while(zhengshu>=Alarm_Temp)
	{
		LCD12864_Clear();    // LCDı
		LCD12864_Show_hz(0,0,"Ͷ....");
		Delay_nms(500);
		Send_CHNews();  // Ķ
		if ( USART_flag )
		  {
		     USART_flag = 0;
		  	 LCD12864_Show_hz(0,0,"Ͷųɹ ^_^");
		  }
		Read_18B20();
	}
}
/***********************************************************
* ƣMENU_Yanwu
* ܣ
*           ڲ:      ڲ
***********************************************************/

void MENU_YANWU( void )
{
	YanWu();   //
}


/***********************************************************
* ƣMENU_FB
* ܣ˵׺
*           ڲ:loca, mode    ڲ
***********************************************************/

void MENU_FB(u8 loca,u8 mode)
{
 u8 temp[6]={0};
 if ( mode )   // mode=1  
 {
	 temp[loca]=0xff; 
	 LCD12864_FB(0,1,temp[0],8);  LCD12864_FB(4,1,temp[1],8);
	 LCD12864_FB(8,0,temp[2],8);  LCD12864_FB(12,0,temp[3],8); 
	 LCD12864_FB(8,1,temp[4],8);  LCD12864_FB(12,1,temp[5],8);
 }  
 else 
 {
   	 temp[loca]=0x00; 
	 LCD12864_FB(0,1,temp[0],8);  LCD12864_FB(4,1,temp[1],8);
	 LCD12864_FB(8,0,temp[2],8);  LCD12864_FB(12,0,temp[3],8); 
	 LCD12864_FB(8,1,temp[4],8);  LCD12864_FB(12,1,temp[5],8);
 } 
}

/***********************************************************
* ƣSystem_Init
* ܣϵͳʼ
*           ڲ:     ڲ
***********************************************************/

void System_Init( void )
{
	USART_Init();			 // ڳʼ
	KEY_Init( );						// ʼ
	Red_Init();
	DS1302_Init();          // DS1302ʼ
	Read_18B20();
	LCD12864_Init( ); 				    // LCDʼ
	LCD12864_Clear_GDRAM( );			// ָ
	LCD12864_Clear();				    // 
}


/***********************************************************
* ƣMENU_KEYHandle
* ܣ˵
*           ڲ:     ڲ
***********************************************************/

void MENU_Handle( void )
{
	u8 key;
	u8 caidan[3]={0}; 
	u8 caidan_ji=0;
	u8 flag=0;	// ־
	  MENU_YANWU( );  // 
	  MENU_ShowTemperature();// ʾ¶Ⱥ
	  MENU_ShowTime( );      // ʾʱ˵
	  if ( IRDA_key==17 ) 
	  {
	  		flag=1;
			LCD12864_Clear();						 // 
			MENU_A0();
	  }
	  else flag=0;
		  while(flag)
		  {
		 	 while(1)
			 {
				  key=KEY_Scan();
				  if((key==1)||(IRDA_key==10))
				  {
					   IRDA_key = 255;
					   if(caidan[caidan_ji]>0)
					    caidan[caidan_ji]--;
					   else
					    caidan[caidan_ji]=5;
				  }
				 
				  if((key==2)||(IRDA_key==11))
				  {
				       IRDA_key = 255;
					   if(caidan[caidan_ji]<5)
					    caidan[caidan_ji]++;
					   else
					    caidan[caidan_ji]=0;
				  }
				 
				  if((key==3)||(IRDA_key==13))
				  {
				   if(caidan_ji<2)
				    caidan_ji++;
				  }
				 
				  if((key==4)||(IRDA_key==12))
				  {
				   if(caidan_ji>0)
				    caidan_ji--;
			      }
				  if((key==3)||(key==4)||(IRDA_key==12)||(IRDA_key==13))
				    { IRDA_key = 255; break;}
				if ( (caidan_ji!=2) )
				  MENU_FB(caidan[caidan_ji], 1 );
			 }
			 switch(caidan_ji)
			 {
				  case 0: 
				  {   
					  MENU_A0();
				      caidan[1]=0; 
				  }break;
				  case 1:
				  { 
					  switch(caidan[0])
					    {
						     case 0 : 
							 {
						          MENU_FB(caidan[1], 1);
								  MENU_B0();
						     }break;
						     case 1 : 
							 {
						          MENU_FB(caidan[1], 1);
								  MENU_B1();
						       }break;
						     case 2 : 
							 {
						          MENU_FB(caidan[1], 1);
								  MENU_B2();
						     }break;
						     case 3 : 
							 {
							      MENU_FB(caidan[1], 1);
								  MENU_B3();
						     }break;
						     case 4 : 
							 {
						          MENU_FB(caidan[1], 1);
								  MENU_B4();
						     } break;
						     case 5 : 
							 {
						          flag=0;
								  MENU_FB(caidan[1], 0);
						     }break;
					         default: break;
					    }
			  }break;
			  case 2: 
			  {	
			  	 switch (caidan[0])
				 {
			     	case 0: 
				    {
			  		    switch(caidan[1])// ˵ 
					    {	 
						     case 0:MENU_JD(0);break;
							 case 1:MENU_JD(1);break;
							 case 2:MENU_JD(2);break;
							 case 3:MENU_JD(3);break;
							 case 4:MENU_JD(4);break;
							 case 5:MENU_JD(5);break;
					         default:break; 
						 }
					 }break;
					 case 1:
					 {
					 	switch(caidan[1])// ˵
					    {
							 case 0:MENU_CallON();break;
							 case 1:MENU_CallOFF();break;
							 case 2:MENU_GetCall();break;
							 case 3:MENU_News();break;
							 case 4:MENU_NULL();break;
							 case 5:MENU_NULL();break;
					         default: break;
						}	
					 }break;
					 case 2:
					 {
					 	switch(caidan[1]) // ˵
					    {

							 case 0:MENU_SetAlarmTemp();break;
						     case 1:MENU_SetTime();break; 
						     case 2:MENU_NULL();break;
							 case 3:MENU_NULL();break;
							 case 4:MENU_NULL();break;
							 case 5:MENU_NULL();break;
					         default: break;
						 }
					 }break;
					 case 3:
					 {
					 	switch(caidan[1]) // ˵
					    {
						     case 0:MENU_Counter();break;
							 case 1:MENU_NULL();break;
							 case 2:MENU_NULL();break;
							 case 3:MENU_NULL();break;
							 case 4:MENU_NULL();break;
							 case 5:MENU_Version();break;
					        default:break; 
						}
					 }break;
				     case 4:
					 {
					 	switch(caidan[1]) // ˵
					    {
						     case 0:MENU_NULL();break;
							 case 1:MENU_NULL();break;
							 case 2:MENU_NULL();break;
							 case 3:MENU_NULL();break;
							 case 4:MENU_NULL();break;
							 case 5:MENU_NULL();break;
					        default:break; 
						}
					 }break;		
					 default:LCD12864_Clear();break;
				  }	
			  }break;

			  default:break;
			 } 
		  }
}


