/*****************************
* @File Name: SYS.H
* @Author	: JZHG
* @Time     : 2012-11-05
* @Version  : V1.0
******************************/

#ifndef _SYS_H_
#define _SYS_H_
#include <reg52.h>

/************************************
*		
*************************************/

#define uchar unsigned char	 // 궨uchar
#define uint unsigned int	 // 궨uint

typedef unsigned long  u32;
typedef unsigned short u16;
typedef unsigned char  u8;


/************************************
*		USART
*************************************/

#define USART_RxBufMAX		25		    // ջСΪ25bytes
extern char USART_RxBuf[USART_RxBufMAX];	// 崮ڽݻ
extern u8 USART_RxPoint;				// Rxָ
extern bit USART_flag;			    // ȴϢ󣬽GTM900Ӧı־

/************************
*	   P4˿
*************************/

sfr P4 = 0xe8;

sbit P40 = 0xe8;
sbit P41 = 0xe9;
sbit P42 = 0xea;
sbit P43 = 0xeb;
sbit P44 = 0xec;
sbit P45 = 0xed;
sbit P46 = 0xee;

/*****************************
*		SYS 
******************************/

void Delay_nms( u16 ms );      // ʱnms 
void Delay_n10us( uchar us );  // ʱn10us
void USART_Init(void);			 // ڳʼ
void USART_SendChar(uchar ch);	 // ͵ַ
void USART_SendStr(uchar *str);  //	ַ

///////////////////////////////
#endif
