/*****************************
* @File Name: LCD12864.H
* @Author	: JZHG
* @Time     : 2012-11-05
* @Version  : V1.0
******************************/

#ifndef _LCD12864_H_
#define _LCD12864_H_
#include "SYS.h"


/*****************************
*		LCD ˿ڶ
******************************/

sbit LCD12864_RS=P1^0;	 // ָ/ѡź
sbit LCD12864_RW=P1^1;	 // дź
sbit LCD12864_E =P1^2;	 // ʹź
sbit LCD12864_RST=P2^6;	 // λź
sbit LCD12864_PSB=P2^7;	 // /ѡ
sbit LCD12864_BF=P0^7;	 // æµ־

#define LCD12864_PORT P0 // ݶ˿
#define LCD12864_COM 0		     // ָ
#define LCD12864_DAT 1		     // 


/*****************************
*		LCD 
******************************/

uchar LCD12864_Check_Busy( void );              // LCDæµ
void LCD12864_Write_Data( uchar mode, uchar dat );     // LCDдݺ
void LCD12864_Init( void ); 						   // LCDʼ
void LCD12864_Clear(void);						 // 
void LCD12864_Clear_GDRAM( void );				 // ָ
void LCD12864_SetXY(u8 y,u8 x);   	  			 // LCD꺯
void LCD12864_Show_hz(uchar x,uchar y,uchar code *p);   // ʾֺ
void LCD12864_ShowNum( u8 x, u8 y,  u8 num );			// LCDʾһλֺ
void LCD12864_ShowNumS( u8 x, u8 y, u8 num, u8 dat[] ); // LCDʾһֺ
//void LCD12864_Draw(uchar stx,uchar sty,uchar enx,uchar eny,uchar code *p); // LCDͼ
void LCD12864_FB(u8 x, u8 y, u8 value, u8 font_num); // LCDⷴ׺

///////////////////////////////
#endif
